
namespace xf
{

/*
 * not marked 'experimental' like Eigen inverse(), but less accurate
 */
template <typename Real>
rgbd::eigen::Transform<Real,3,rgbd::eigen::Affine>
invertTransform(rgbd::eigen::Transform<Real,3,rgbd::eigen::Affine> const& T)
{
	rgbd::eigen::Translation<Real,3> trans(T.translation());
	rgbd::eigen::Quaternion<Real> q(T.linear());
	trans = trans.inverse();
	q = q.inverse();
	return q*trans;
}

template <typename Real>
rgbd::eigen::Matrix<Real,7,1> convertTransformToVector(rgbd::eigen::Transform<Real,3,rgbd::eigen::Affine> const& t)
{
	rgbd::eigen::Quaternion<Real> q = rgbd::eigen::Quaternion<Real>(t.linear());
	rgbd::eigen::Matrix<Real,3,1> translation = t.translation();

	rgbd::eigen::Matrix<Real,7,1> vector;
	vector[0] = q.w();
	vector[1] = q.x();
	vector[2] = q.y();
	vector[3] = q.z();
	vector[4] = translation.x();
	vector[5] = translation.y();
	vector[6] = translation.z();

	return vector;
}

template <typename Real>
rgbd::eigen::Transform<Real,3,rgbd::eigen::Affine> convertVectorToTransform(rgbd::eigen::Matrix<Real,7,1> const& v)
{
	rgbd::eigen::Quaternion<Real> q(v[0],v[1],v[2],v[3]);
	rgbd::eigen::Matrix<Real,3,1> t(v[4],v[5],v[6]);
	rgbd::eigen::Transform<Real,3,rgbd::eigen::Affine> transform(q.normalized().toRotationMatrix());
	transform.pretranslate(t);

	return transform;
}


template <typename Real>
rgbd::eigen::Quaternion<Real> getQuaternionPart(rgbd::eigen::Matrix<Real,7,1> const& v)
{
	rgbd::eigen::Quaternion<Real> q(v[0],v[1],v[2],v[3]);
	return q.normalized();
}

}
